Index: uspace/app/usbinfo/info.c
===================================================================
--- uspace/app/usbinfo/info.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/usbinfo/info.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,19 +27,50 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbinfo
  * @{
  */
 /**
  * @file
- * @brief
+ * Dumping of generic device properties.
  */
 #include <stdio.h>
 #include <str_error.h>
 #include <errno.h>
-#include <usb/usbdrv.h>
+#include <usb/pipes.h>
+#include <usb/recognise.h>
+#include <usb/request.h>
 #include "usbinfo.h"
 
-int dump_device(int hc_phone, usb_address_t address)
+int dump_device(devman_handle_t hc_handle, usb_address_t address)
 {
+	int rc;
+	usb_device_connection_t wire;
+	usb_endpoint_pipe_t ctrl_pipe;
+
+	/*
+	 * Initialize pipes.
+	 */
+	rc = usb_device_connection_initialize(&wire, hc_handle, address);
+	if (rc != EOK) {
+		fprintf(stderr,
+		    NAME ": failed to create connection to the device: %s.\n",
+		    str_error(rc));
+		goto leave;
+	}
+	rc = usb_endpoint_pipe_initialize_default_control(&ctrl_pipe, &wire);
+	if (rc != EOK) {
+		fprintf(stderr,
+		    NAME ": failed to create default control pipe: %s.\n",
+		    str_error(rc));
+		goto leave;
+	}
+	rc = usb_endpoint_pipe_start_session(&ctrl_pipe);
+	if (rc != EOK) {
+		fprintf(stderr,
+		    NAME ": failed to start session on control pipe: %s.\n",
+		    str_error(rc));
+		goto leave;
+	}
+
 	/*
 	 * Dump information about possible match ids.
@@ -47,10 +78,10 @@
 	match_id_list_t match_id_list;
 	init_match_ids(&match_id_list);
-	int rc = usb_drv_create_device_match_ids(hc_phone, &match_id_list, address);
+	rc = usb_device_create_match_ids(&ctrl_pipe, &match_id_list);
 	if (rc != EOK) {
 		fprintf(stderr,
 		    NAME ": failed to fetch match ids of the device: %s.\n",
 		    str_error(rc));
-		return rc;
+		goto leave;
 	}
 	dump_match_ids(&match_id_list);
@@ -60,17 +91,12 @@
 	 */
 	usb_standard_device_descriptor_t device_descriptor;
-	usb_dprintf(NAME, 1,
-	    "usb_drv_req_get_device_descriptor(%d, %d, %p)\n",
-	    hc_phone, (int) address, &device_descriptor);
-
-	rc = usb_drv_req_get_device_descriptor(hc_phone, address,
-	    &device_descriptor);
+	rc = usb_request_get_device_descriptor(&ctrl_pipe, &device_descriptor);
 	if (rc != EOK) {
 		fprintf(stderr,
 		    NAME ": failed to fetch standard device descriptor: %s.\n",
 		    str_error(rc));
-		return rc;
-	}
-	dump_standard_device_descriptor(&device_descriptor);
+		goto leave;
+	}
+	dump_usb_descriptor((uint8_t *)&device_descriptor, sizeof(device_descriptor));
 
 	/*
@@ -79,26 +105,16 @@
 	usb_standard_configuration_descriptor_t config_descriptor;
 	int config_index = 0;
-	usb_dprintf(NAME, 1,
-	    "usb_drv_req_get_bare_configuration_descriptor(%d, %d, %d, %p)\n",
-	    hc_phone, (int) address, config_index, &config_descriptor);
-
-	rc = usb_drv_req_get_bare_configuration_descriptor(hc_phone, address,
-	    config_index, &config_descriptor );
+	rc = usb_request_get_bare_configuration_descriptor(&ctrl_pipe,
+	    config_index, &config_descriptor);
 	if (rc != EOK) {
 		fprintf(stderr,
 		    NAME ": failed to fetch standard configuration descriptor: %s.\n",
 		    str_error(rc));
-		return rc;
-	}
-	dump_standard_configuration_descriptor(config_index,
-	    &config_descriptor);
+		goto leave;
+	}
+	//dump_standard_configuration_descriptor(config_index, &config_descriptor);
 
 	void *full_config_descriptor = malloc(config_descriptor.total_length);
-	usb_dprintf(NAME, 1,
-	    "usb_drv_req_get_full_configuration_descriptor(%d, %d, %d, %p, %zu)\n",
-	    hc_phone, (int) address, config_index,
-	    full_config_descriptor, config_descriptor.total_length);
-
-	rc = usb_drv_req_get_full_configuration_descriptor(hc_phone, address,
+	rc = usb_request_get_full_configuration_descriptor(&ctrl_pipe,
 	    config_index,
 	    full_config_descriptor, config_descriptor.total_length, NULL);
@@ -107,13 +123,76 @@
 		    NAME ": failed to fetch full configuration descriptor: %s.\n",
 		    str_error(rc));
-		return rc;
-	}
-	dump_buffer("Full configuration descriptor:",
-	    full_config_descriptor, config_descriptor.total_length);
+		goto leave;
+	}
 
 	dump_descriptor_tree(full_config_descriptor,
 	    config_descriptor.total_length);
 
-	return EOK;
+	/*
+	 * Get supported languages of STRING descriptors.
+	 */
+	l18_win_locales_t *langs;
+	size_t langs_count;
+	rc = usb_request_get_supported_languages(&ctrl_pipe,
+	    &langs, &langs_count);
+	if (rc != EOK) {
+		fprintf(stderr,
+		    NAME ": failed to get list of supported languages: %s.\n",
+		    str_error(rc));
+		goto skip_strings;
+	}
+
+	printf("String languages (%zu):", langs_count);
+	size_t i;
+	for (i = 0; i < langs_count; i++) {
+		printf(" 0x%04x", (int) langs[i]);
+	}
+	printf(".\n");
+
+	/*
+	 * Dump all strings in all available langages;
+	 */
+	for (i = 0; i < langs_count; i++) {
+		l18_win_locales_t lang = langs[i];
+
+		printf("%sStrings for language 0x%04x:\n", get_indent(0),
+		    (int) lang);
+
+		/*
+		 * Try all indexes - we will see what pops-up ;-).
+		 * However, to speed things up, we will stop after
+		 * encountering several broken (or nonexistent ones)
+		 * descriptors in line.
+		 */
+		size_t idx;
+		size_t failed_count = 0;
+		for (idx = 1; idx < 0xFF; idx++) {
+			char *string;
+			rc = usb_request_get_string(&ctrl_pipe, idx, lang,
+			    &string);
+			if (rc != EOK) {
+				failed_count++;
+				if (failed_count > 3) {
+					break;
+				}
+				continue;
+			}
+			printf("%sString #%zu: \"%s\"\n", get_indent(1),
+			    idx, string);
+			free(string);
+			failed_count = 0; /* Reset failed counter. */
+		}
+	}
+
+
+skip_strings:
+
+	rc = EOK;
+
+leave:
+	/* Ignoring errors here. */
+	usb_endpoint_pipe_end_session(&ctrl_pipe);
+
+	return rc;
 }
 
Index: uspace/app/usbinfo/main.c
===================================================================
--- uspace/app/usbinfo/main.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/usbinfo/main.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,10 +27,10 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbinfo
  * @{
  */
 /**
  * @file
- * @brief USB querying.
+ * USB querying.
  */
 
@@ -43,5 +43,4 @@
 #include <devman.h>
 #include <devmap.h>
-#include <usb/usbdrv.h>
 #include "usbinfo.h"
 
@@ -77,72 +76,36 @@
 }
 
-static int set_new_host_controller(int *phone, const char *path)
+static int get_host_controller_handle(const char *path,
+    devman_handle_t *hc_handle)
 {
 	int rc;
-	int tmp_phone;
 
-	if (path[0] != '/') {
-		int hc_class_index = (int) strtol(path, NULL, 10);
-		char *dev_path;
-		rc = asprintf(&dev_path, "class/usbhc\\%d", hc_class_index);
-		if (rc < 0) {
-			internal_error(rc);
-			return rc;
-		}
-		devmap_handle_t handle;
-		rc = devmap_device_get_handle(dev_path, &handle, 0);
-		if (rc < 0) {
-			fprintf(stderr,
-			    NAME ": failed getting handle of `devman://%s'.\n",
-			    dev_path);
-			free(dev_path);
-			return rc;
-		}
-		tmp_phone = devmap_device_connect(handle, 0);
-		if (tmp_phone < 0) {
-			fprintf(stderr,
-			    NAME ": could not connect to `%s'.\n",
-			    dev_path);
-			free(dev_path);
-			return tmp_phone;
-		}
-		free(dev_path);
-	} else {
-		devman_handle_t handle;
-		rc = devman_device_get_handle(path, &handle, 0);
-		if (rc != EOK) {
-			fprintf(stderr,
-			    NAME ": failed getting handle of `devmap::/%s'.\n",
-			    path);
-			return rc;
-		}
-		tmp_phone = devman_device_connect(handle, 0);
-		if (tmp_phone < 0) {
-			fprintf(stderr,
-			    NAME ": could not connect to `%s'.\n",
-			    path);
-			return tmp_phone;
-		}
+	if (str_cmp(path, "uhci") == 0) {
+		path = "/hw/pci0/00:01.2/uhci";
 	}
 
-	*phone = tmp_phone;
+	devman_handle_t handle;
+	rc = devman_device_get_handle(path, &handle, 0);
+	if (rc != EOK) {
+		fprintf(stderr,
+		    NAME ": failed getting handle of `devman::/%s'.\n",
+		    path);
+		return rc;
+	}
+	*hc_handle = handle;
 
 	return EOK;
 }
 
-static int connect_with_address(int hc_phone, const char *str_address)
+static int get_device_address(const char *str_address, usb_address_t *address)
 {
-	usb_address_t address = (usb_address_t) strtol(str_address, NULL, 0);
-	if ((address < 0) || (address >= USB11_ADDRESS_MAX)) {
+	usb_address_t addr = (usb_address_t) strtol(str_address, NULL, 0);
+	if ((addr < 0) || (addr >= USB11_ADDRESS_MAX)) {
 		fprintf(stderr, NAME ": USB address out of range.\n");
 		return ERANGE;
 	}
 
-	if (hc_phone < 0) {
-		fprintf(stderr, NAME ": no active host controller.\n");
-		return ENOENT;
-	}
-
-	return dump_device(hc_phone, address);
+	*address = addr;
+	return EOK;
 }
 
@@ -150,5 +113,6 @@
 int main(int argc, char *argv[])
 {
-	int hc_phone = -1;
+	devman_handle_t hc_handle = (devman_handle_t) -1;
+	usb_address_t device_address = (usb_address_t) -1;
 
 	if (argc <= 1) {
@@ -175,5 +139,6 @@
 			case 'a':
 			case ACTION_DEVICE_ADDRESS: {
-				int rc = connect_with_address(hc_phone, optarg);
+				int rc = get_device_address(optarg,
+				    &device_address);
 				if (rc != EOK) {
 					return rc;
@@ -184,6 +149,6 @@
 			case 't':
 			case ACTION_HOST_CONTROLLER: {
-				int rc = set_new_host_controller(&hc_phone,
-				    optarg);
+				int rc = get_host_controller_handle(optarg,
+				   &hc_handle);
 				if (rc != EOK) {
 					return rc;
@@ -202,4 +167,12 @@
 	} while (i != -1);
 
+	if ((hc_handle == (devman_handle_t) -1)
+	    || (device_address == (usb_address_t) -1)) {
+		fprintf(stderr, NAME ": no target specified.\n");
+		return EINVAL;
+	}
+
+	dump_device(hc_handle, device_address);
+
 	return 0;
 }
Index: uspace/app/usbinfo/usbinfo.h
===================================================================
--- uspace/app/usbinfo/usbinfo.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/usbinfo/usbinfo.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,9 +27,9 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbinfo
  * @{
  */
 /** @file
- * @brief Common header for usbinfo application.
+ * Common header for usbinfo application.
  */
 #ifndef USBINFO_USBINFO_H_
@@ -44,10 +44,9 @@
 #define NAME "usbinfo"
 
-void dump_buffer(const char *, const uint8_t *, size_t);
+void dump_buffer(const char *, size_t, const uint8_t *, size_t);
+const char *get_indent(size_t);
 void dump_match_ids(match_id_list_t *matches);
-void dump_standard_device_descriptor(usb_standard_device_descriptor_t *);
-void dump_standard_configuration_descriptor(int, 
-    usb_standard_configuration_descriptor_t *);
-int dump_device(int, usb_address_t);
+void dump_usb_descriptor(uint8_t *, size_t);
+int dump_device(devman_handle_t, usb_address_t);
 void dump_descriptor_tree(uint8_t *, size_t);
 
Index: uspace/app/virtusbhub/Makefile
===================================================================
--- uspace/app/virtusbhub/Makefile	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
+++ uspace/app/virtusbhub/Makefile	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -0,0 +1,62 @@
+#
+# Copyright (c) 2011 Vojtech Horky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+# acronym for virtual USB hub
+# (it is really annoying to write long names)
+BINARY = vuh
+
+LIBS = $(LIBUSB_PREFIX)/libusb.a $(LIBUSBVIRT_PREFIX)/libusbvirt.a
+EXTRA_CFLAGS = -DSTANDALONE_HUB \
+	-DHUB_PORT_COUNT=10 \
+	-I$(LIBUSB_PREFIX)/include -I$(LIBUSBVIRT_PREFIX)/include -I$(LIBDRV_PREFIX)/include
+
+SOURCES = \
+	main.c \
+	$(STOLEN_VHC_SOURCES)
+
+STOLEN_VHC_SOURCES = \
+	vhc_hub/hub.c \
+	vhc_hub/virthub.c \
+	vhc_hub/virthubops.c 
+STOLEN_VHC_HEADERS = \
+	vhc_hub/hub.h \
+	vhc_hub/virthub.h
+
+PRE_DEPEND = $(STOLEN_VHC_SOURCES) $(STOLEN_VHC_HEADERS)
+
+EXTRA_CLEAN = $(STOLEN_VHC_SOURCES) $(STOLEN_VHC_HEADERS)
+
+HUB_IN_VHC = $(USPACE_PREFIX)/drv/vhc/hub
+
+include $(USPACE_PREFIX)/Makefile.common
+
+vhc_hub/%.h: $(HUB_IN_VHC)/%.h
+	ln -sfn ../$(HUB_IN_VHC)/$*.h $@
+vhc_hub/%.c: $(HUB_IN_VHC)/%.c
+	ln -sfn ../$(HUB_IN_VHC)/$*.c $@
Index: uspace/app/virtusbhub/main.c
===================================================================
--- uspace/app/virtusbhub/main.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
+++ uspace/app/virtusbhub/main.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -0,0 +1,102 @@
+/*
+ * Copyright (c) 2011 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup usbvirthub
+ * @{
+ */
+/**
+ * @file
+ * @brief Virtual USB hub.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <str_error.h>
+#include <bool.h>
+
+#include <usb/usb.h>
+#include <usb/descriptor.h>
+#include <usb/classes/hub.h>
+#include <usbvirt/device.h>
+#include <usbvirt/hub.h>
+
+#include "vhc_hub/virthub.h"
+
+#define NAME "vuh"
+
+static usbvirt_device_t hub_device;
+
+#define VERBOSE_SLEEP(sec, msg, ...) \
+	do { \
+		char _status[HUB_PORT_COUNT + 2]; \
+		printf(NAME ": doing nothing for %zu seconds...\n", \
+		    (size_t) (sec)); \
+		fibril_sleep((sec)); \
+		virthub_get_status(&hub_device, _status, HUB_PORT_COUNT + 1); \
+		printf(NAME ": " msg " [%s]\n" #__VA_ARGS__, _status); \
+	} while (0)
+
+static void fibril_sleep(size_t sec)
+{
+	while (sec-- > 0) {
+		async_usleep(1000*1000);
+	}
+}
+
+static int dev1 = 1;
+
+int main(int argc, char * argv[])
+{
+	int rc;
+
+	printf(NAME ": virtual USB hub.\n");
+
+	rc = virthub_init(&hub_device);
+	if (rc != EOK) {
+		printf(NAME ": Unable to start communication with VHCD (%s).\n",
+		    str_error(rc));
+		return rc;
+	}
+	
+	while (true) {
+		VERBOSE_SLEEP(8, "will pretend device plug-in...");
+		virthub_connect_device(&hub_device, &dev1);
+
+		VERBOSE_SLEEP(8, "will pretend device un-plug...");
+		virthub_disconnect_device(&hub_device, &dev1);
+	}
+
+	usbvirt_disconnect(&hub_device);
+	
+	return 0;
+}
+
+
+/** @}
+ */
Index: uspace/app/virtusbkbd/descriptor.h
===================================================================
--- uspace/app/virtusbkbd/descriptor.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/descriptor.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
Index: uspace/app/virtusbkbd/items.h
===================================================================
--- uspace/app/virtusbkbd/items.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/items.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
Index: uspace/app/virtusbkbd/kbdconfig.c
===================================================================
--- uspace/app/virtusbkbd/kbdconfig.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/kbdconfig.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
@@ -61,5 +61,5 @@
 	.endpoint_count = 1,
 	.interface_class = USB_CLASS_HID,
-	.interface_subclass = 0,
+	.interface_subclass = USB_HID_SUBCLASS_BOOT,
 	.interface_protocol = USB_HID_PROTOCOL_KEYBOARD,
 	.str_interface = 0
Index: uspace/app/virtusbkbd/kbdconfig.h
===================================================================
--- uspace/app/virtusbkbd/kbdconfig.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/kbdconfig.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
Index: uspace/app/virtusbkbd/keys.c
===================================================================
--- uspace/app/virtusbkbd/keys.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/keys.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
Index: uspace/app/virtusbkbd/keys.h
===================================================================
--- uspace/app/virtusbkbd/keys.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/keys.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
@@ -40,5 +40,5 @@
 
 /** Maximum number of keys that can be pressed simultaneously. */
-#define KB_MAX_KEYS_AT_ONCE 4
+#define KB_MAX_KEYS_AT_ONCE 6
 
 /** Key code type. */
Index: uspace/app/virtusbkbd/report.h
===================================================================
--- uspace/app/virtusbkbd/report.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/report.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
Index: uspace/app/virtusbkbd/stdreq.c
===================================================================
--- uspace/app/virtusbkbd/stdreq.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/stdreq.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
Index: uspace/app/virtusbkbd/stdreq.h
===================================================================
--- uspace/app/virtusbkbd/stdreq.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/stdreq.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
Index: uspace/app/virtusbkbd/virtusbkbd.c
===================================================================
--- uspace/app/virtusbkbd/virtusbkbd.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/app/virtusbkbd/virtusbkbd.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup usbvirtkbd
  * @{
  */
@@ -271,8 +271,8 @@
 	printf("%s: Simulating keyboard events...\n", NAME);
 	fibril_sleep(10);
-	while (1) {
+	//while (1) {
 		kb_process_events(&status, keyboard_events, keyboard_events_count,
 			on_keyboard_change);
-	}
+	//}
 	
 	printf("%s: Terminating...\n", NAME);
Index: uspace/doc/doxygroups.h
===================================================================
--- uspace/doc/doxygroups.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/doc/doxygroups.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -176,2 +176,76 @@
 	 * @brief Library for creating USB devices drivers.
 	 */
+
+	/**
+	 * @defgroup usbvirt USB virtualization
+	 * @ingroup usb
+	 * @brief Support for virtual USB devices.
+	 */
+
+		/**
+		 * @defgroup libusbvirt USB virtualization library
+		 * @ingroup usbvirt
+		 * @brief Library for creating virtual USB devices.
+		 */
+
+		/**
+		 * @defgroup drvusbvhc Virtual USB host controller
+		 * @ingroup usbvirt
+		 * @brief Driver simulating work of USB host controller.
+		 */
+
+		/**
+		 * @defgroup usbvirthub Virtual USB hub
+		 * @ingroup usbvirt
+		 * @brief Extra virtual USB hub for virtual host controller.
+		 * @details
+		 * Some of the sources are shared with virtual host controller,
+		 * see @ref drvusbvhc for the rest of the files.
+		 */
+
+		/**
+		 * @defgroup usbvirtkbd Virtual USB keybaord
+		 * @ingroup usbvirt
+		 * @brief Virtual USB keyboard for virtual host controller.
+		 */
+
+	/**
+	 * @defgroup usbinfo USB info application
+	 * @ingroup usb
+	 * @brief Application for querying USB devices.
+	 * @details
+	 * The intended usage of this application is to query new USB devices
+	 * for their descriptors etc. to simplify driver writing.
+	 */
+
+	/**
+	 * @defgroup drvusbmid USB multi interface device driver
+	 * @ingroup usb
+	 * @brief USB multi interface device driver
+	 * @details
+	 * This driver serves as a mini hub (or bus) driver for devices
+	 * that have the class defined at interface level (those devices
+	 * usually have several interfaces).
+	 *
+	 * The term multi interface device driver (MID) was borrowed
+	 * Solaris operating system.
+	 */
+
+	/**
+	 * @defgroup drvusbhub USB hub driver
+	 * @ingroup usb
+	 * @brief USB hub driver.
+	 */
+
+	/**
+	 * @defgroup drvusbhid USB HID driver
+	 * @ingroup usb
+	 * @brief USB driver for HID devices.
+	 */
+
+	/**
+	 * @defgroup drvusbuhci UHCI driver
+	 * @ingroup usb
+	 * @brief Driver for USB host controller UHCI.
+	 */
+
